import themes from '../themes';
import languages from '../languages';

const loaders = {
    theme: themes,
    language: languages
};

export default async function loadModule(type, name) {
    const load = loaders[type] && loaders[type][name];

    if (typeof load === 'function') {
        try {
            await load();
        } catch (error) {
            console.error(
                `[loadModule] error loading ${type} "${name}"`,
                error
            );
        }
    } else {
        console.warn(`Unsupported ${type} "${name}"`, {
            supported: Object.keys(loaders[type])
        });
    }
}
